
/* Chrysalide - Outil d'analyse de fichiers binaires
 * module.c - intégration du répertoire elf en tant que module
 *
 * Copyright (C) 2013 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include "module.h"


#include "elf.h"



/******************************************************************************
*                                                                             *
*  Paramètres  : module = module dont la définition est à compléter.          *
*                                                                             *
*  Description : Ajoute le module 'format.elf' au module Python.              *
*                                                                             *
*  Retour      : -                                                            *
*                                                                             *
*  Remarques   : -                                                            *
*                                                                             *
******************************************************************************/

bool add_format_elf_module_to_python_module(PyObject *super)
{
    bool result;                            /* Bilan à retourner           */
    PyObject *module;                       /* Sous-module mis en place    */
    int ret;                                /* Bilan d'un appel            */

    static PyModuleDef py_chrysalide_elf_module = {

        .m_base = PyModuleDef_HEAD_INIT,

        .m_name = "pychrysalide.format.elf",
        .m_doc = "Python module for Chrysalide.format.elf",

        .m_size = -1,

    };

    result = false;

    module = PyModule_Create(&py_chrysalide_elf_module);
    if (module == NULL) return false;

    ret = PyState_AddModule(super, &py_chrysalide_elf_module);
    if (ret != 0) goto loading_failed;

    ret = _PyImport_FixupBuiltin(module, "pychrysalide.format.elf");
    if (ret != 0) goto loading_failed;

    Py_INCREF(module);
    ret = PyModule_AddObject(super, "elf", module);
    if (ret != 0) goto loading_failed;

    result = true;

    result &= register_python_elf_format(module);

 loading_failed:

    return result;

}
