
/* Chrysalide - Outil d'analyse de fichiers binaires
 * processor.h - prototypes pour la gestion de l'architecture x86
 *
 * Copyright (C) 2008-2012 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _ARCH_X86_PROCESSOR_H
#define _ARCH_X86_PROCESSOR_H


#include "../processor.h"
#include "instruction.h"    /* FIXME : remme */



#define G_TYPE_X86_PROCESSOR                g_x86_processor_get_type()
#define G_X86_PROCESSOR(obj)                (G_TYPE_CHECK_INSTANCE_CAST((obj), g_x86_processor_get_type(), GX86Processor))
#define G_IS_X86_PROCESSOR(obj)             (G_TYPE_CHECK_INSTANCE_TYPE((obj), g_x86_processor_get_type()))
#define G_X86_PROCESSOR_GET_IFACE(inst)     (G_TYPE_INSTANCE_GET_INTERFACE((inst), g_x86_processor_get_type(), GX86ProcessorIface))


/* Définition du processeur de la x86 (instance) */
typedef struct _GX86Processor GX86Processor;

/* Définition du processeur de la x86 (classe) */
typedef struct _GX86ProcessorClass GX86ProcessorClass;


/* Indique le type défini par la GLib pour le processeur x86. */
GType g_x86_processor_get_type(void);

/* Crée le support de l'architecture x86. */
GArchProcessor *g_x86_processor_new(void);

/* Fournit la taille supplantée des opérandes pour x86. */
MemoryDataSize g_x86_processor_get_operand_size(const GX86Processor *, X86Prefix);



#endif  /* _ARCH_X86_PROCESSOR_H */
