
/* Chrysalide - Outil d'analyse de fichiers binaires
 * cond.h - prototypes pour la représentation des conditions
 *
 * Copyright (C) 2010-2013 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _DECOMP_EXPR_COND_H
#define _DECOMP_EXPR_COND_H


#include <glib-object.h>


#include "../expression.h"
#include "../output.h"



#define G_TYPE_COND_EXPRESSION               g_cond_expression_get_type()
#define G_COND_EXPRESSION(obj)               (G_TYPE_CHECK_INSTANCE_CAST((obj), g_cond_expression_get_type(), GCondExpression))
#define G_IS_COND_EXPRESSION(obj)            (G_TYPE_CHECK_INSTANCE_TYPE((obj), g_cond_expression_get_type()))
#define G_COND_EXPRESSION_CLASS(klass)       (G_TYPE_CHECK_CLASS_CAST((klass), G_TYPE_COND_EXPRESSION, GCondExpressionClass))
#define G_IS_COND_EXPRESSION_CLASS(klass)    (G_TYPE_CHECK_CLASS_TYPE((klass), G_TYPE_COND_EXPRESSION))
#define G_COND_EXPRESSION_GET_CLASS(obj)     (G_TYPE_INSTANCE_GET_CLASS((obj), G_TYPE_COND_EXPRESSION, GCondExpressionClass))



/* Définition d'une condition binaire quelconque (instance) */
typedef struct _GCondExpression GCondExpression;

/* Définition d'une condition binaire quelconque (classe) */
typedef struct _GCondExpressionClass GCondExpressionClass;


/* Indique le type défini pour une condition binaire quelconque. */
GType g_cond_expression_get_type(void);

/* Exprime une condition binaire quelconque. */
GDecExpression *g_cond_expression_new(GDecExpression *);

/* Fournit l'opération logique entre les comparaisons. */
CondOperatorType g_cond_expression_get_operator(const GCondExpression *);

/* Fournit l'expression d'une condition. */
GDecExpression *g_cond_expression_get_expression(const GCondExpression *);

/* Définit l'expression d'une condition. */
void g_cond_expression_set_expression(GCondExpression *, GDecExpression *);

/* Etend l'expression d'une condition. */
void g_cond_expression_add_condition(GCondExpression *, GCondExpression *, CondOperatorType);



#endif  /* _DECOMP_EXPR_COND_H */
