
/* Chrysalide - Outil d'analyse de fichiers binaires
 * text.h - prototypes pour le raccord avec les opérandes de chaînes de caractères
 *
 * Copyright (C) 2012 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _DECOMP_EXPR_TEXT_H
#define _DECOMP_EXPR_TEXT_H


#include <glib-object.h>


#include "../instruction.h"



#define G_TYPE_STR_EXPRESSION               g_str_expression_get_type()
#define G_STR_EXPRESSION(obj)               (G_TYPE_CHECK_INSTANCE_CAST((obj), g_str_expression_get_type(), GStrExpression))
#define G_IS_STR_EXPRESSION(obj)            (G_TYPE_CHECK_INSTANCE_TYPE((obj), g_str_expression_get_type()))
#define G_STR_EXPRESSION_CLASS(klass)       (G_TYPE_CHECK_CLASS_CAST((klass), G_TYPE_STR_EXPRESSION, GStrExpressionClass))
#define G_IS_STR_EXPRESSION_CLASS(klass)    (G_TYPE_CHECK_CLASS_TYPE((klass), G_TYPE_STR_EXPRESSION))
#define G_STR_EXPRESSION_GET_CLASS(obj)     (G_TYPE_INSTANCE_GET_CLASS((obj), G_TYPE_STR_EXPRESSION, GStrExpressionClass))



/* Définition d'une expression de valeur immédiate (instance) */
typedef struct _GStrExpression GStrExpression;

/* Définition d'une expression de valeur immédiate (classe) */
typedef struct _GStrExpressionClass GStrExpressionClass;



/* Indique le type défini pour une expression de valeur immédiate. */
GType g_str_expression_get_type(void);

/*Construit une expression à partir d'une valeur immédiate. */
GDecInstruction *g_str_expression_new(const char *);



#endif  /* _DECOMP_EXPR_TEXT_H */
