
/* Chrysalide - Outil d'analyse de fichiers binaires
 * java.h - prototypes pour les sorties en langage Java
 *
 * Copyright (C) 2010 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _DECOMP_LANG_JAVA_H
#define _DECOMP_LANG_JAVA_H


#include "../output.h"



#define G_TYPE_JAVA_OUTPUT               g_java_output_get_type()
#define G_JAVA_OUTPUT(obj)               (G_TYPE_CHECK_INSTANCE_CAST((obj), g_java_output_get_type(), GJavaOutput))
#define G_IS_JAVA_OUTPUT(obj)            (G_TYPE_CHECK_INSTANCE_TYPE((obj), g_java_output_get_type()))
#define G_JAVA_OUTPUT_CLASS(klass)       (G_TYPE_CHECK_CLASS_CAST((klass), G_TYPE_JAVA_OUTPUT, GJavaOutputClass))
#define G_IS_JAVA_OUTPUT_CLASS(klass)    (G_TYPE_CHECK_CLASS_TYPE((klass), G_TYPE_JAVA_OUTPUT))
#define G_JAVA_OUTPUT_GET_CLASS(obj)     (G_TYPE_INSTANCE_GET_CLASS((obj), G_TYPE_JAVA_OUTPUT, GJavaOutputClass))


/* Sortie selon le langage Java (instance) */
typedef struct _GJavaOutput GJavaOutput;

/* Sortie selon le langage Java (classe) */
typedef struct _GJavaOutputClass GJavaOutputClass;


/* Indique le type défini pour une sortie en langage Java. */
GType g_java_output_get_type(void);

/* Crée une nouvelle sortie en langage Java. */
GLangOutput *g_java_output_new(void);



#endif  /* _DECOMP_LANG_JAVA_H */
