
/* Chrysalide - Outil d'analyse de fichiers binaires
 * d_dwarf.h - prototypes pour le support du format DWARF
 *
 * Copyright (C) 2008 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _FORMAT_DWARF_DWARF_H
#define _FORMAT_DWARF_DWARF_H


#include <stdint.h>
#include <sys/types.h>


#include "../exe_format.h"



/* Description du format DWARF */
typedef struct _dwarf_format dwarf_format;



/* Prend en charge un nouveau DWARF. */
dwarf_format *load_dwarf(const uint8_t *, off_t, exe_format *);

/* Récupère tous les commentaires à insérer dans le code. */
size_t get_dwarf_comments(const dwarf_format *, const char ***, uint64_t **);




#endif  /* _FORMAT_DWARF_DWARF_H */
